using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserWallet;
namespace CMSMicroservice.Protobuf.Validator.UserWallet;

public class GetAllUserWalletByFilterRequestValidator : AbstractValidator<GetAllUserWalletByFilterRequest>
{
    public GetAllUserWalletByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllUserWalletByFilterRequest>.CreateWithOptions((GetAllUserWalletByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
